package gui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.UnsupportedEncodingException;
import java.text.NumberFormat;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.text.BadLocationException;

import app.SerialReader;
import app.SerialWriter;
import gnu.io.CommPort;
import gnu.io.CommPortIdentifier;
import gnu.io.SerialPort;


public class MainFrame extends JFrame{

	/**
	 * 
	 */
	private static final long serialVersionUID = -5917250286317004616L;
	
	JPanel pnlConnect = new JPanel();
	JPanel pnlData = new JPanel();
	JPanel pnlMain = new JPanel();
	JPanel pnlFile = new JPanel();
	JButton btnConnect = new JButton("Pipoj");
	JButton btnSend = new JButton("Nastav");
	JButton btnOpen = new JButton("Otevt");
	JButton btnPlot = new JButton("PLOT!");
	JButton btnStop = new JButton("STOP!");
	JTextField txtPort = new JTextField("COM1");
	JTextField txtData = new JTextField("5000");
	JTextArea txaPloter = new JTextArea();
	JScrollPane scroll = new JScrollPane(txaPloter);
	JLabel lblMessage = new JLabel("Nepipojeno");
	long pauza=5000;
	SerialWriter os;
	SerialReader is;	
	FileInputStream fis = null;
	InputStreamReader isr;
	String[] filterExt = { "txt", "plt", "hpgl"};
	FileFilter filter = new FileNameExtensionFilter("Soubory .txt, .plt, .hpgl",filterExt);
	boolean isConnected=false;
	JFileChooser fc = new JFileChooser();
	
	Thread plot;
	
	public MainFrame(){         
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setPreferredSize(new Dimension(250,600));
		setName("ARITMA 0512 writer");
		setTitle("ARITMA 0512 writer");
		setLayout(new BoxLayout(this.getContentPane(),BoxLayout.Y_AXIS));
		setResizable(false);
		fc.setFileFilter(filter);
		fc.setName("Otevt soubor");
		txtPort.setColumns(10);
		txtData.setColumns(10);
		txaPloter.setColumns(20);
		txaPloter.setRows(27);
		pnlMain.setPreferredSize(new Dimension((int)this.getPreferredSize().getWidth(),400));
		btnConnect.setPreferredSize(new Dimension(80,20));
		btnSend.setPreferredSize(new Dimension(80,20));
		pnlFile.setMaximumSize(new Dimension((int)this.getPreferredSize().getWidth(),30));
		pnlConnect.setMaximumSize(new Dimension((int)this.getPreferredSize().getWidth(),30));
		pnlData.setMaximumSize(new Dimension((int)this.getPreferredSize().getWidth(),30));
		lblMessage.setPreferredSize(new Dimension((int)this.getPreferredSize().getWidth(),20));
		lblMessage.setHorizontalTextPosition(JLabel.LEFT);
		
		add(pnlFile);
		add(pnlConnect);
		add(lblMessage);
		add(pnlData);
		pnlFile.add(btnOpen);
		pnlFile.add(btnPlot);
		pnlFile.add(btnStop);
		pnlConnect.add(txtPort);
		pnlConnect.add(btnConnect);
		pnlData.add(txtData);
		pnlData.add(btnSend);
		add(pnlMain);
		pnlMain.add(scroll);
		scroll.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		scroll.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		pack();
		btnStop.setEnabled(false);
		btnPlot.setEnabled(false);
		btnStop.addActionListener(new ActionListener(){
			@Override
			public void actionPerformed(ActionEvent arg0) {
					plot.stop();
					btnStop.setEnabled(false);
					btnPlot.setEnabled(true);
					lblMessage.setText("Odeslno!");
			}
		});
		
		btnPlot.addActionListener(new ActionListener(){
			@Override
			public void actionPerformed(ActionEvent arg0) {
				final char c = 27;
				if(isConnected){
					lblMessage.setText("Odeslm...");
					plot = new Thread(){
						public void run(){
								for(int i=0;i<txaPloter.getLineCount();i++){
									try {
										System.out.println("____________________");
										System.out.println("Prikaz c.: "+i);
										os.write(c+".B");
										Thread.sleep(100);
										String ret = is.getReturned();
										System.out.println("RET : "+ret);
										//if(!ret.isEmpty())
											if(Integer.valueOf(ret)>67){
												if(txaPloter.getLineStartOffset(i)!= txaPloter.getLineEndOffset(i)){
													txaPloter.select(txaPloter.getLineStartOffset(i), txaPloter.getLineEndOffset(i));
													String text = txaPloter.getSelectedText();
													os.write(text);
													System.out.print("Prikaz: "+text);
												}
											}else{
												Thread.sleep(pauza);
												i--;
											}
										System.out.println("====================");
										Thread.sleep(50);
									} catch (BadLocationException e) {
										e.printStackTrace();
									} catch (InterruptedException e) {
										// TODO Auto-generated catch block
										e.printStackTrace();
									}
								}
								btnStop.setEnabled(false);
								btnPlot.setEnabled(true);								
						}
					};
					plot.start();
					btnStop.setEnabled(true);
					btnPlot.setEnabled(false);
				}
			}
		});
		
		btnSend.addActionListener(new ActionListener(){
			@Override
			public void actionPerformed(ActionEvent arg0) {
				pauza=Long.parseLong(txtData.getText());
			}			
		});
		
		btnConnect.addActionListener(new ActionListener(){
			@Override
			public void actionPerformed(ActionEvent arg0) {
				lblMessage.setText("Pipojuji...");
				try{
					connect(txtPort.getText());
					isConnected=true;
					btnConnect.setEnabled(false);
					btnPlot.setEnabled(true);
					final char c = 27;
					os.write(c+".B");
					Thread.sleep(30);
					String ret = is.getReturned();
					System.out.println("Vychozi zasobnik :"+ret);
					lblMessage.setText("Pipojeno");
				}catch (Exception e) {
					isConnected=false;
					btnConnect.setEnabled(true);
					btnPlot.setEnabled(false);
					System.out.println(e.getMessage());
					lblMessage.setText("Nepipojeno");
				}	
			}
		});
		
		btnOpen.addActionListener(new ActionListener(){
			@Override
			public void actionPerformed(ActionEvent arg0) {
				int returnVal = fc.showOpenDialog(pnlMain);
		        if (returnVal == JFileChooser.APPROVE_OPTION) {
		            File file = fc.getSelectedFile();
		            try {
						fis = new FileInputStream(file);
						isr = new InputStreamReader(fis);
						StringBuffer text = new StringBuffer("");
						int ch;
						while((ch = fis.read()) != -1)
							text.append((char)ch);
						txaPloter.setText(text.toString());
						fis.close();
						isr.close();
					} catch (FileNotFoundException e1) {
						e1.printStackTrace();
					}catch (UnsupportedEncodingException e) {
						e.printStackTrace();
					}catch (IOException e) {
						e.printStackTrace();
					}
		        } else {
		            txaPloter.setText("Soubor nenalezen!");
		        }	
			}
		});
	}

	void connect(String portName) throws Exception{
        CommPortIdentifier portIdentifier = CommPortIdentifier.getPortIdentifier(portName);
        if(portIdentifier.isCurrentlyOwned()){
            System.out.println("Error: Port is currently in use");
            System.out.println("by "+portIdentifier.getCurrentOwner());
            lblMessage.setText("Port je vyuvn aplikac: "+portIdentifier.getCurrentOwner());
        }else{
            CommPort commPort = portIdentifier.open(this.getClass().getName(),2000);
            if(commPort instanceof SerialPort){
            	
                SerialPort serialPort = (SerialPort) commPort;
                serialPort.setSerialPortParams(9600,SerialPort.DATABITS_7,SerialPort.STOPBITS_1,SerialPort.PARITY_EVEN);
                serialPort.setFlowControlMode(SerialPort.FLOWCONTROL_XONXOFF_IN);
                
                InputStream in = serialPort.getInputStream();
                OutputStream out = serialPort.getOutputStream();
                is = new SerialReader(in);
                os = new SerialWriter(out);
                (new Thread(is)).start();
                (new Thread(os)).start();
            }else{
            	System.out.println("Error: Only serial ports are handled by this example.");
            	lblMessage.setText("Je mon pouvat pouze sriov port!");
            }
        }     
    }
}